#!/usr/bin/python
#shuber, 2008-06-04

__author__ = "shuber"


import gtk
import vte

import WatchesFrame
import BreakpointsFrame


class StatusWindow (gtk.Window):

	def __init__(self, mainctrlwnd, debugger, closecb=None):

		gtk.Window.__init__(self)
		self.set_screen(mainctrlwnd.get_screen())

		self.set_border_width(5)
		self.set_title("Status")
		self.set_default_size(400,600)

		if closecb!=None:
			self.connect("destroy", lambda *w: closecb())


		#Register callback function for new positions
		self.mainctrlwnd = mainctrlwnd
		mainctrlwnd.newPosCbs += [self.updateValues]


		vbox = gtk.VBox(False, 5)
		self.add(vbox)

		self.status = gtk.Label("Not Running")
		vbox.pack_start(self.status, False, False)
		vpaned = gtk.VPaned()
		vbox.add(vpaned)

		self.watchesFrame = WatchesFrame.WatchesFrame(debugger)
		vpaned.add1(self.watchesFrame)

		self.breakpointsFrame = BreakpointsFrame.BreakpointsFrame(debugger)
		vpaned.add2(self.breakpointsFrame)

		self.show_all()


	def updateValues(self, pos):

		if pos == None:
			self.status.set_text("Exited")
		else:
			file, lineno = pos
			self.status.set_text("%s:%s" % (file, lineno))

		self.watchesFrame.updateValues()
		self.breakpointsFrame.updateValues()


